/* misc.c */
/* This file holds code imported from elsewhere */

#include <gtk/gtk.h>
#include "gtkdialog.h"
#ifdef USEPIXBUF
#include <gdk-pixbuf/gdk-pixbuf.h>	//GN
#include <gdk-pixbuf/gdk-pixbuf-loader.h>	//GN
#include <png.h>
#endif

#define SMALL_HEIGHT 20
#define SMALL_WIDTH 24

#if defined USEPIXBUF || USE_GTK2
/// From ROX: Scale src down to fit in max_w, max_h and return the new pixbuf.
/// If src is small enough, then ref it and return that.
GdkPixbuf *scale_pixbuf(GdkPixbuf *src, int max_w, int max_h) {
	int	w, h;

	w = gdk_pixbuf_get_width(src);
	h = gdk_pixbuf_get_height(src);

	if (w <= max_w && h <= max_h) {
		gdk_pixbuf_ref(src);
		return src;
	} else {
		float scale_x = ((float) w) / max_w;
		float scale_y = ((float) h) / max_h;
		float scale = MAX(scale_x, scale_y);
		int dest_w = w / scale;
		int dest_h = h / scale;
		
		return gdk_pixbuf_scale_simple(src,	MAX(dest_w, 1),	MAX(dest_h, 1),
			GDK_INTERP_BILINEAR);
	}
}

/// From ROX: Scale src up to fit in max_w, max_h and return the new pixbuf.
/// If src is that size or bigger, then ref it and return that.
GdkPixbuf *scale_pixbuf_up(GdkPixbuf *src, int max_w, int max_h) {
	int	w, h;

	w = gdk_pixbuf_get_width(src);
	h = gdk_pixbuf_get_height(src);

	if (w == 0 || h == 0 || (w >= max_w && h >= max_h)) {
		gdk_pixbuf_ref(src);
		return src;
	} else {
		float scale_x = max_w / ((float) w);
		float scale_y = max_h / ((float) h);
		float scale = MIN(scale_x, scale_y);
		
		return gdk_pixbuf_scale_simple(src,	w * scale, h * scale,
			GDK_INTERP_BILINEAR);
	}
}
#endif

